local ____lualib = require("lualib_bundle")
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____isaac_2Dtypescript_2Ddefinitions = require("isaac-typescript-definitions")
local ModCallback = ____isaac_2Dtypescript_2Ddefinitions.ModCallback
local ____shouldFire = require("shouldFire")
local shouldFireProjectile = ____shouldFire.shouldFireProjectile
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
local v = {room = {firedSet = __TS__New(Set)}}
____exports.PostProjectileInitLate = __TS__Class()
local PostProjectileInitLate = ____exports.PostProjectileInitLate
PostProjectileInitLate.name = "PostProjectileInitLate"
__TS__ClassExtends(PostProjectileInitLate, CustomCallback)
function PostProjectileInitLate.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.v = v
    self.shouldFire = shouldFireProjectile
    self.postProjectileUpdate = function(____, projectile)
        local ptrHash = GetPtrHash(projectile)
        if not v.room.firedSet:has(ptrHash) then
            v.room.firedSet:add(ptrHash)
            self:fire(projectile)
        end
    end
    self.callbacksUsed = {{ModCallback.POST_PROJECTILE_UPDATE, self.postProjectileUpdate}}
end
return ____exports
